// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2007                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : R.Nagashima
//    : 2007/01/09 
//
//-------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FVDATASLib;

namespace Blob
{
    public partial class frmBlobResult : Form
    {
        public frmBlobResult()
        {
            InitializeComponent();
        }

        public int m_BlobNo = -1;
        public int m_MaxBlobNo  = 0;
        public frmMain m_owner;
        private const double PI = 3.14159265358979;

        
        private void frmBlobResult_Load(object sender, EventArgs e)
        {
            m_owner = (frmMain)this.Owner;//etH[
            DrawAll();            
        }

        private void DrawAll()
        {
            FvBlobResultGroup BlobResultGroup = new FvBlobResultGroup();
            FvPoint Point = new FvPoint(); 

            txtBlobNo.Text = "ALL";
            txtResult.Text = string.Format("Su[uF {0:0}", m_MaxBlobNo + 1 );

            //e_CAOʐ
            m_owner.axFvxDisplayEx1.ClearOverlay(-1);

            m_owner.axFvxDisplayEx1.ClearOverlay(-1);
            //͈͂ŕ\
            m_owner.axFvxDisplayEx1.PenColor = Color.GreenYellow;
            m_owner.axFvxDisplayEx1.DrawData(0, m_owner.m_ExeRegion);

            m_owner.axFvxDisplayEx1.PenColor = Color.Blue;
            m_owner.axFvxDisplayEx1.FontColor = Color.Red;

            //ʂ̎擾
            m_owner.axFvxBlob1.GetResult(0, BlobResultGroup);

            //dS_ƊOڒ``
            m_owner.axFvxDisplayEx1.DrawData(0, BlobResultGroup);

            for (int i = 0; i <= m_MaxBlobNo; i++)
            {
                Point.x = BlobResultGroup.Item4(i).center_x;
                Point.y = BlobResultGroup.Item4(i).center_y;
                m_owner.axFvxDisplayEx1.DrawText(0, Point, i.ToString());
            }
          }

        private void btnExitform_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnNext_Click(object sender, EventArgs e)
        {
            if (m_MaxBlobNo == -1)
            {
                DrawAll();
                return;
            }
            m_BlobNo++;

            if (m_BlobNo > m_MaxBlobNo)
            {
                m_BlobNo = m_MaxBlobNo;
            }
            DrawOne(m_BlobNo);        
        }

        private void DrawOne(int Num)
        {
            FvBlobResult BlobResult = new FvBlobResult();
            FvLine Line = new FvLine();
            FvEllipse Ellipse = new FvEllipse();//ȉ~f[^
            double dblAngle;

            txtBlobNo.Text = Num.ToString();

            //I[o[Cʂ̏
            m_owner.axFvxDisplayEx1.ClearOverlay(-1);

            //u[uڍ׏擾
            m_owner.axFvxBlob1.GetResult(Num, BlobResult);

            //u[ȕڍׂȏeLXg{bNXɕ\
            txtResult.Text = string.Format("܂܂Ȃʐ : {0:0}\r\n" + 
                                            " : {1:0}\r\n" +
                                            "͒ : {2:0}\r\n" +
                                            "ȉ~厲 : {3:0.00}\r\n" +
                                            "ȉ~ : {4:0.00}\r\n" +
                                            "ȉ~XΊp : {5:0.00}\r\n" +
                                            "dSW : ( {6:0.00} , {7:0.00} )\r\n" +
                                            "Xŏl : {8:0}\r\n" +
                                            "Xől : {9:0}\r\n" +
                                            "Yŏl : {10:0}\r\n" +
                                            "Yől : {11:0}\r\n" +
                                            "܂߂ʐ : {12:0}\r\n" +
                                            "Oڒ`@ : ( {13:0.00} , {14:0.00} )\r\n" +
                                            "Oڒ`@E : ( {15:0.00} , {16:0.00} )\r\n" +
                                            "Oڒ`@ : ( {17:0.00} , {18:0.00} )\r\n" +
                                            "Oڒ`@E : ( {19:0.00} , {20:0.00} )\r\n",
                                            BlobResult.area,
                                            BlobResult.hole_num,
                                            BlobResult.perim,
                                            BlobResult.ellipse_long,
                                            BlobResult.ellipse_short,
                                            BlobResult.ellipse_angle,
                                            BlobResult.center_x,
                                            BlobResult.center_y,
                                            BlobResult.x_min,
                                            BlobResult.x_max,
                                            BlobResult.y_min,
                                            BlobResult.y_max,
                                            BlobResult.total_area,
                                            BlobResult.bounding_top_x,
                                            BlobResult.bounding_top_y,
                                            BlobResult.bounding_right_x,
                                            BlobResult.bounding_right_y,
                                            BlobResult.bounding_left_x,
                                            BlobResult.bounding_left_y,
                                            BlobResult.bounding_bottom_x,
                                            BlobResult.bounding_bottom_y);

            //ȉ~\
            Ellipse.angle = BlobResult.ellipse_angle;
            Ellipse.axis_x = BlobResult.ellipse_long;
            Ellipse.axis_y = BlobResult.ellipse_short;
            Ellipse.x = BlobResult.center_x;
            Ellipse.y = BlobResult.center_y;
            m_owner.axFvxDisplayEx1.DrawData(0, Ellipse);

            //dSʂAȉ~̒yђZ̒
            //dS_ : ( X1, y1 )  ȉ~XΊp : ƂƂƁA̎
            // - xsin + ycos + ( x1sin - y1cos ) = 0
            dblAngle = BlobResult.ellipse_angle * PI / 180;
            Line.a = -System.Math.Sin( dblAngle );
            Line.b = System.Math.Cos(dblAngle);
            Line.c = (BlobResult.center_x * System.Math.Sin(dblAngle)) - (BlobResult.center_y * System.Math.Cos(dblAngle));
            m_owner.axFvxDisplayEx1.DrawData(0, Line);

            dblAngle = (BlobResult.ellipse_angle + 90) * PI / 180;
            Line.a = -System.Math.Sin(dblAngle);
            Line.b = System.Math.Cos(dblAngle);
            Line.c = (BlobResult.center_x * System.Math.Sin(dblAngle)) - (BlobResult.center_y * System.Math.Cos(dblAngle));
            m_owner.axFvxDisplayEx1.DrawData(0, Line);
            
            //dS_ƊOڒ`̕`
            m_owner.axFvxDisplayEx1.DrawData(0, BlobResult);
        }

        private void btnBack_Click(object sender, EventArgs e)
        {
            m_BlobNo = m_BlobNo - 1;
            if (m_BlobNo < -1)
                m_BlobNo = -1;
            if (m_BlobNo == -1)
                DrawAll();
            else
                DrawOne(m_BlobNo);
        }
    }
}